function MainTriLatticeTemper()
{
   var ctx_X = canvas_densitas_Vx.getContext("2d");
   var width_X = canvas_densitas_Vx.width;
   var height_X = canvas_densitas_Vx.height;

   var ctx_Y = canvas_densitas_Vy.getContext("2d");
   var width_Y = canvas_densitas_Vy.width;
   var height_Y = canvas_densitas_Vy.height;

   var ctx_E = canvas_energy.getContext("2d");
   var width_E = canvas_energy.width;
   var height_E = canvas_energy.height;

   //     

   var _Vx;
   var _Vy;
   var Vx2_sum; //     Vx (  s)
   var Vy2_sum; //     Vy (  s)
   var Vx4_sum; //  (  Vx)^4 (  s)
   var Vy4_sum; //  (  Vy)^4 (  s)
   var U1x_sum, U1y_sum;

   var suspended = 0; //   == 1
   
   //  

   var Arr_prt = [];

   var n1 = 30; //   1
   var n2 = 30;
   var n = n1 * n2; //  
   //var a = 1; //     
   //var c = 1; //    
   //var m = 1; //  
   //var _m = c/m;
   var dt_sc_m = 0.01; //     dt_sc_m = dt*sqrt(c_m)

   //var dt_out = 10; //    (  )

   //var Arr_prt = Array(n2);

   //    (  )

   var Vx = 10;
   var Vy = 0.1;
   var Vc_x = 0; // 
   var Vc_y = 0; //  

   var K1 = []; // . 
   var P = []; // . 

   slider_input_X.value = Vx;
   number_input_X.value = Vx;
   slider_input_Y.value = Vy;
   number_input_Y.value = Vy;
   sV_axis = 0;
   // var str = "arr=\n";

   var s = 0;   //   
   var V_max;   //     
   var sV_max;  //       
   var norm = 0; //       == 1
   var Par = []; //    RandomNorm()

   function RandomNorm() // <(Par[0])^2> == 1, <(Par[1])^2> == 1
   {
		var r_RandomNorm = Math.sqrt(-2*Math.log(Math.random()));
		var fi_RandomNorm = Math.random()*Math.PI*2;

		Par[0] = r_RandomNorm*Math.cos(fi_RandomNorm);
		Par[1] = r_RandomNorm*Math.sin(fi_RandomNorm);
   }

   function Restart()
   {
		Vx = number_input_X.value;
		Vy = number_input_Y.value;

		for (var j = 0; j < n2; j++)
		{
			Arr_prt[j] = [];
			//Arr_prt[j] = Array(n1);

			for (var i = 0; i < n1; i++)
			{
				if (norm)
				{
					RandomNorm();
					_Vx = Par[0];
					_Vy = Par[1];
				}
				else
					do
					{
						_Vx = 2*Math.random()-1;
						_Vy = 2*Math.random()-1;
					}
					while (_Vx*_Vx+_Vy*_Vy > 1);

				//_Vx *= Vx; //     -Vx  Vx
				//_Vy *= Vy; //     -Vy  Vy

				Vc_x += _Vx;
				Vc_y += _Vy;
			        
				var particle = {};
				particle.Ux = 0;
				particle.Uy = 0;
				particle.Vx = _Vx;
				particle.Vy = _Vy;

				Arr_prt[j][i] = particle;

				//str += Arr_prt[j][i].Vy + "\n";
			}
		}

		Vc_x /= n;
		Vc_y /= n;

		//alert(str + "Vc_x=" + Vc_x + "\nVc_y=" + Vc_y);
		//alert("length=" + Arr_prt.length);
		//var str = "arr=\n";

		//    

		Vx2_sum = 0;
		Vy2_sum = 0;

		for (var j = 0; j < n2; j++)
		{
			for (var i = 0; i < n1; i++)
			{
				Arr_prt[j][i].Vx -= Vc_x;
				Arr_prt[j][i].Vy -= Vc_y;

				//str += Arr_prt[j][i].Vx + "\n";
				_Vx = Arr_prt[j][i].Vx;
				_Vy = Arr_prt[j][i].Vy;
				Vx2_sum += _Vx*_Vx;
				Vy2_sum += _Vy*_Vy;
			}
		}

		//   
		
		Vx2_sum = Vx/Math.sqrt(Vx2_sum/n);
		Vy2_sum = Vy/Math.sqrt(Vy2_sum/n);

		for (var j = 0; j < n2; j++)
		{
			for (var i = 0; i < n1; i++)
			{
				Arr_prt[j][i].Vx *= Vx2_sum;
				Arr_prt[j][i].Vy *= Vy2_sum;
			}
		}

        s = 0;
		//alert(str + "Vc_x=" + Vc_x + "\nVc_y=" + Vc_y);

		sVy_max = sVx_max = Math.max(Math.sqrt(Vx*2), Math.sqrt(Vy*2)); //     

		V_max = 2*Math.max(Vx, Vy); //     

		ExCalculateReset();
		Vx2_sum = 0; Vy2_sum = 0;
		Vx4_sum = 0; Vy4_sum = 0;
		U1x_sum = 0; U1y_sum = 0;
   }

   function Step()
   {
      if (!suspended)
      {
		Calculate();    //    
		ExCalculate();  //    

		s++;
		Paint();             //  
      }
   }

   //Calculate();

   //  
   // x[j][i] = a*i + a/2*(j&1);
   // y[j][i] = sqrt(3)/2*a*j;

   var sqrt3 = Math.sqrt(3);

   function Calculate() //  
   {
      var i, j;

      P[s] = 0;

      for (var k = 0; k < n; k++) //   
      {
         i = k%n1;
         j = Math.floor(k/n1);

         var Ux; var Uy; var U_4; var U_43; var U_1;
         
         if (j > 0)
         {
            var ai = i&1 ? i : i-1; //   1

            if (ai >= 0)
            {
               Ux = Arr_prt[j-1][ai].Ux - Arr_prt[j][i].Ux;
               Uy = Arr_prt[j-1][ai].Uy - Arr_prt[j][i].Uy;
               U_1 = Ux + Uy*sqrt3;
               U_4 = U_1 / 4 * dt_sc_m;
               U_43 = U_4*sqrt3;

               Arr_prt[j][i].Vx += U_4;
               Arr_prt[j][i].Vy += U_43;

               Arr_prt[j-1][ai].Vx -= U_4;
               Arr_prt[j-1][ai].Vy -= U_43;

               P[s] += U_1*U_1/8;
            }

            ai++; //   2

            if (ai < n1)
            {
               Ux = Arr_prt[j-1][ai].Ux - Arr_prt[j][i].Ux;
               Uy = Arr_prt[j-1][ai].Uy - Arr_prt[j][i].Uy;
               U_1 = Uy*sqrt3 - Ux;
               U_4 = U_1 / 4 * dt_sc_m;
               U_43 = U_4*sqrt3;

               Arr_prt[j][i].Vx -= U_4;
               Arr_prt[j][i].Vy += U_43;

               Arr_prt[j-1][ai].Vx += U_4;
               Arr_prt[j-1][ai].Vy -= U_43;

               P[s] += U_1*U_1/8;
            }
         }

         if (i > 0) //   3
         {
            U_1 = Arr_prt[j][i-1].Ux - Arr_prt[j][i].Ux;
            Ux = U_1 * dt_sc_m;

            Arr_prt[j][i].Vx += Ux;
            Arr_prt[j][i-1].Vx -= Ux;

            P[s] += U_1*U_1/2;
         }
      }

      K1[s] = 0;

      //var Ux, Uy, U_4, U_43, U_1;
      //alert("Ux=" + Ux + "\nUy=" + Uy + "\nU_1=" + U_1);

      for (var k = 0; k < n; k++) //  
      {
         i = k%n1;
         //j = k/n1;
         j = Math.floor(k/n1);

         var Vx_loc = Arr_prt[j][i].Vx;
         var Vy_loc = Arr_prt[j][i].Vy;

         Arr_prt[j][i].Ux += Vx_loc * dt_sc_m;
         Arr_prt[j][i].Uy += Vy_loc * dt_sc_m;

         K1[s] += (Vx_loc*Vx_loc+Vy_loc*Vy_loc)/2;
         
         //str += Vx + "\n";
         //str += Vy;
         Vx_loc *= Vx_loc;
         Vy_loc *= Vy_loc;
         Vx2_sum += Vx_loc*s;
         Vy2_sum += Vy_loc*s;

         Vx_loc *= Vx_loc;
         Vy_loc *= Vy_loc;
         Vx4_sum += Vx_loc*s;
         Vy4_sum += Vy_loc*s;

	     //U1x_sum += Arr_prt[j][i].Ux;
         //U1y_sum += Arr_prt[j][i].Uy;
      }

      U1x_sum += Arr_prt[0][0].Ux;
      U1y_sum += Arr_prt[0][0].Uy;
      
      //var str = "P=" + P;
      //alert(str);
      //str = "K=" + K1;
      //alert(str);
   }

   var N_graph_Vx = 20;
   var Vx_dens = [];  //        Vx,
   var Vy_dens = [];  // Vy.
   var sVx_dens = [];  //        sqrt(Vx),
   var sVy_dens = [];  // sqrt(Vy).
   //var K_dens = [];

   function ExCalculateReset()
   {
      for (var i = 0; i < N_graph_Vx; i++)
      {
         Vx_dens[i] = 0;
         Vy_dens[i] = 0;
         sVx_dens[i] = 0;
         sVy_dens[i] = 0;
      }
   }

   var k_sen = 0.1; //      
   span_sen.innerHTML = k_sen;

   function ExCalculate() //     
   {
      var Vx_dens_loc = [];
      var Vy_dens_loc = [];
      var sVx_dens_loc = [];
      var sVy_dens_loc = [];

      for (var i = 0; i < N_graph_Vx; i++)
      {
         Vx_dens_loc[i] = 0;
         Vy_dens_loc[i] = 0;
         sVx_dens_loc[i] = 0;
         sVy_dens_loc[i] = 0;
      }

      ///////////////////////////////////////////////////////////////////////

      for (var k = 0; k < n; k++)
      {
         i = k%n1;
         j = Math.floor(k/n1);

         var Vx_loc = Math.abs(Arr_prt[j][i].Vx);
         var Vy_loc = Math.abs(Arr_prt[j][i].Vy);
         var sVx_loc = Math.sqrt(Vx_loc);
         var sVy_loc = Math.sqrt(Vy_loc);

         var n_d = Math.floor(Vx_loc/V_max*N_graph_Vx);//
         if (n_d < N_graph_Vx) { Vx_dens_loc[n_d]++; }
         
         n_d = Math.floor(Vy_loc/V_max*N_graph_Vx);
         if (n_d < N_graph_Vx) { Vy_dens_loc[n_d]++; }

         n_d = Math.floor(sVx_loc/sVx_max*N_graph_Vx);
         if (n_d < N_graph_Vx) { sVx_dens_loc[n_d]++; }
         
         n_d = Math.floor(sVy_loc/sVy_max*N_graph_Vx);
         if (n_d < N_graph_Vx) { sVy_dens_loc[n_d]++; }
      }

      ///////////////////////////////////////////////////////////////////////

      for (var i = 0; i < N_graph_Vx; i++)
      {
         Vx_dens[i] = k_sen*Vx_dens_loc[i] + (1-k_sen)*Vx_dens[i];
         Vy_dens[i] = k_sen*Vy_dens_loc[i] + (1-k_sen)*Vy_dens[i];
         sVx_dens[i] = k_sen*sVx_dens_loc[i] + (1-k_sen)*sVx_dens[i];
         sVy_dens[i] = k_sen*sVy_dens_loc[i] + (1-k_sen)*sVy_dens[i];
      }
   }

   function Paint()
   {
      ctx_X.strokeStyle="#0000ff";
      Draw(ctx_X, width_X, height_X, sV_axis ? sVx_dens : Vx_dens);

      ctx_Y.strokeStyle="#ff0000";
      Draw(ctx_Y, width_Y, height_Y, sV_axis ? sVy_dens : Vy_dens);

      var Vx2_aver = Vx2_sum / s / (s > 1 ? s-1 : 1) * 2 / n;
      var Vy2_aver = Vy2_sum / s / (s > 1 ? s-1 : 1) * 2 / n;

      //span_Vx2.innerHTML = "< Vx^2 > = " + (Vx2_sum/n/s).toFixed(3);
      //span_Vy2.innerHTML = "< Vy^2 > = " + (Vy2_sum/n/s).toFixed(3);
      //span_V2.innerHTML = "< Vx^2 + Vy^2 > = " + ((Vx2_sum+Vy2_sum)/n/s).toFixed(3);
      span_Vx2.innerHTML = Vx2_aver.toFixed(3);
      span_Vy2.innerHTML = Vy2_aver.toFixed(3);
      span_V2.innerHTML = (Vx2_aver+Vy2_aver).toFixed(3);
      //span_U.innerHTML = "< Ux > = " + (U1x_sum/s).toFixed(2) + 
		//"________ < Uy > = " + (U1y_sum/s).toFixed(2);

      var Vx4_aver = Vx4_sum / s / (s > 1 ? s-1 : 1) * 2 / n;
      var Vy4_aver = Vy4_sum / s / (s > 1 ? s-1 : 1) * 2 / n;

      span_Mx.innerHTML = (Vx4_aver/Vx2_aver/Vx2_aver/3).toFixed(3);
      span_My.innerHTML = (Vy4_aver/Vy2_aver/Vy2_aver/3).toFixed(3);

      span_k1.innerHTML = ((Vx2_aver+Vy2_aver) / (Vx*Vx+Vy*Vy)).toFixed(3);
      span_k2.innerHTML = ((Vx2_aver-Vy2_aver) / (Vx*Vx-Vy*Vy)).toFixed(3);
      span_1k2.innerHTML = ((Vx*Vx-Vy*Vy) / (Vx2_aver-Vy2_aver)).toFixed(3);

      DrawE();

      span_E.innerHTML = ((K1[s-1] + P[s-1])/n).toFixed(2);
      span_t.innerHTML = (s*dt_sc_m).toFixed(2);
      span_steps.innerHTML = s;
   }

   function Draw(ctx, width, height, V_dens) //        Vx, Vy
   {
        ///////////////////////////////////////////////////////////////////////

        ctx.lineWidth="0.6";                    //  
        ctx.clearRect(0, 0, width, height);     //  
        ctx.beginPath();

        var dens_V_max = 1;                     //   
        for (var i = 0; i < N_graph_Vx; i++)
        {
           if (V_dens[i] > dens_V_max) { dens_V_max = V_dens[i]; }
        }

		dens_V_max *= 1.1;                      //  

        var x_scal = width / (N_graph_Vx-1);    // N_graph_Vx-1 ==    N_graph_Vx 
        var y_scal = height / dens_V_max;

        var x = 0;
        var y = Math.floor(height - y_scal*V_dens[0]);

        ctx.moveTo(x, y);

        var n_points = Math.floor(width / 3);

        for (var i = 1; i < n_points; i++)
        {
			y = 0;
			x = 3*i;

			var j = Math.floor(x/x_scal);
			var fi = x/x_scal - j;                       // 0 <= fi < 1

			if (j >= N_graph_Vx-1) alert("error!");

			//   

			y += V_dens[j] * (fi-1) * (fi-1) * (2*fi+1); // 
			y += V_dens[j+1] * fi * fi * (3-2*fi);       //  

			var y_d = (j == 0) ? V_dens[1]-V_dens[0] : (V_dens[j+1]-V_dens[j-1])/2;

			y += y_d * (fi-1) * (fi-1) * fi;       //    

			y_d = (j == N_graph_Vx-2) ? V_dens[N_graph_Vx-1]-V_dens[N_graph_Vx-2] : (V_dens[j+2]-V_dens[j])/2;

			y += y_d * fi * fi * (fi-1);           //    

			y = Math.floor(height - y_scal*y);     //     
			y = Math.max(0, y);
			y = Math.min(y, height);

			ctx.lineTo(x, y);
        }

		y = Math.floor(height - y_scal*V_dens[N_graph_Vx-1]);
		y = Math.min(y, height);
		ctx.lineTo(width, y);

        ctx.stroke();

        ///////////////////////////////////////////////////////////////////////
   }

   function DrawE() //     
   {
		// :

        ctx_E.strokeStyle="#004000";
        ctx_E.lineWidth="0.7";                        //  
        ctx_E.clearRect(0, 0, width_E, height_E);     //  
        ctx_E.beginPath();

		var K_max = K1[0];

        /*for (var i = 0; i < s; i++)
        {
			if (K1[i] > K_max) K_max = K1[i];
			if (P[i] > K_max) K_max = P[i];
        }*/

		//var x_scal = width_E / Math.max(s, 1000);
		var x_scal = width_E / 1000;
		var y_scal = height_E / K_max;

		var i0 = Math.max(0, s-1000);

        var x = 0;
        var y = Math.floor(height_E - K1[i0]*y_scal);

        ctx_E.moveTo(x, y);

        for (var i = i0+1; i < s; i++)
        {
			y = Math.floor(height_E - K1[i]*y_scal);
			x = Math.ceil((i-i0)*x_scal);

			ctx_E.lineTo(x, y);
        }

        ctx_E.stroke();

		//   <E> = K(0)/2

        y = Math.floor(height_E - K1[0]*y_scal/2);

        ctx_E.strokeStyle="#000000";
        ctx_E.beginPath();
        ctx_E.moveTo(0, y);
		ctx_E.lineTo(width_E, y);
        ctx_E.stroke();

        // :
/*
        ctx_E.beginPath();

        ctx_E.strokeStyle="#0000ff";

        x = 0;
        y = Math.floor(height_E - P[0]*y_scal);

        ctx_E.moveTo(x, y);

        for (var i = 0; i < s; i++)
        {
			y = Math.floor(height_E - P[i]*y_scal);
			x = Math.floor(i*x_scal);

			ctx_E.lineTo(x, y);
        }

        ctx_E.stroke();*/
   }

   slider_sen.oninput = function()
   {
       k_sen = span_sen.innerHTML = slider_sen.value;
   };
   number_input_X.oninput = function()
   {
       slider_input_X.value = number_input_X.value;
       Restart();
   };
   slider_input_X.oninput = function()
   {
       number_input_X.value = slider_input_X.value;
       Restart();
   };
   number_input_Y.oninput = function()
   {
       slider_input_Y.value = number_input_Y.value;
       Restart();
   };
   slider_input_Y.oninput = function()
   {
       number_input_Y.value = slider_input_Y.value;
       Restart();
   };
   reset_calc.onclick = function()
   {
       if (suspended) suspend_calc.onclick();
       Restart();
   };
   suspend_calc.onclick = function()
   {
       suspended = !suspended;
       var str = suspend_calc.value;
       suspend_calc.value = suspend_calc.name;
       suspend_calc.name = str;
   };
   number_input_n1.oninput = function()
   {
       if (number_input_n1.value >= 10)
       {
			slider_input_n1.value = number_input_n1.value;
			span_n1.innerHTML = " x " + number_input_n1.value;
			n2 = n1 = number_input_n1.value;
			n = n1*n2;

			span_n.innerHTML = n;
			Restart();
	   }
   };
   slider_input_n1.oninput = function()
   {
	   number_input_n1.value = slider_input_n1.value;

       if (slider_input_n1.value >= 10)
       {
			span_n1.innerHTML = " x " + number_input_n1.value;
			n2 = n1 = number_input_n1.value;
			n = n1*n2;

			span_n.innerHTML = n;
			Restart();
	   }
   };
   radio_V.onchange = function() { sV_axis = 0; span_sqrt1.innerHTML = span_sqrt2.innerHTML = ""; Paint(); };
   radio_sV.onchange = function() { sV_axis = 1; span_sqrt1.innerHTML = span_sqrt2.innerHTML = "sqrt"; Paint(); };

   radio_CV.onchange = function() { norm = 0; Restart(); };
   radio_NV.onchange = function() { norm = 1; Restart(); };

   Restart();
   setInterval(Step, 1000 / 30);               //  step   30    ( 1000 )
}
